// 地图省份
var mapList = [{
    name: '北京',
    value: 0
}, {
    name: '天津',
    value: 0
}, {
    name: '上海',
    value: 0
}, {
    name: '重庆',
    value: 0
}, {
    name: '河北',
    value: 0
}, {
    name: '河南',
    value: 0
}, {
    name: '云南',
    value: 0
}, {
    name: '辽宁',
    value: 0
}, {
    name: '黑龙江',
    value: 0
}, {
    name: '湖南',
    value: 0
}, {
    name: '安徽',
    value: 0
}, {
    name: '山东',
    value: 0
}, {
    name: '新疆',
    value: 0
}, {
    name: '江苏',
    value: 0
}, {
    name: '浙江',
    value: 0
}, {
    name: '江西',
    value: 0
}, {
    name: '湖北',
    value: 0
}, {
    name: '广西',
    value: 0
}, {
    name: '甘肃',
    value: 0
}, {
    name: '山西',
    value: 0
}, {
    name: '内蒙古',
    value: 0
}, {
    name: '陕西',
    value: 0
}, {
    name: '吉林',
    value: 0
}, {
    name: '福建',
    value: 0
}, {
    name: '贵州',
    value: 0
}, {
    name: '广东',
    value: 0
}, {
    name: '青海',
    value: 0
}, {
    name: '西藏',
    value: 0
}, {
    name: '四川',
    value: 0
}, {
    name: '宁夏',
    value: 0
}, {
    name: '海南',
    value: 0
}, {
    name: '台湾',
    value: 0
}, {
    name: '香港',
    value: 0
}, {
    name: '澳门',
    value: 0
}, {
    name: "南海诸岛",
    value: 0
}]
var mobflag = sessionStorage.getItem("ismobi")
var visualMap_max = 0;

// 创建图表
var createChartCommon = function(config) {
    var option = {};
    switch (config.type) {
        case "percent": // 百分比
            option = {
                tooltip: {
                    trigger: 'item',
                    // formatter: '数量: {c} ({d}%)'
                    formatter: function(data){
                        var html = ""
                            html += "撤诉文书数量:" + config.xAxisData[1] +'<br>' 
                            html += "裁判文书总量:" + (1*config.xAxisData[0] + 1*config.xAxisData[1])
                        return html
                    }
                },
                formatter: function (params) {
                    return 
                },
                color:["#F4F8F9","#4486F6"],
                series: [
                    {
                        type: 'pie',
                        radius: ['50%', '70%'],
                        avoidLabelOverlap: false,
                        label: {
                            show: true,
                            position: 'center'
                        },
                        emphasis: {
                            label: {
                                show: true,
                                fontSize: '30',
                                fontWeight: 'bold'
                            }
                        },
                        labelLine: {
                            show: true
                        },
                        data: [
                            {value: config.xAxisData[0], name: ''},
                            {value: config.xAxisData[1], name: config.series,label: {
                                show: true,
                                fontSize: '30',
                                fontWeight: 'bold',
                                color:"#333"
                            }}
                            
                        ]
                    }
                ]
            };
            break;
        case 'diagram': // 关系图

        break;
        case 'three': // 三列柱形图
            option = {
                color: ['#3398DB'],
                tooltip: {
                    trigger: 'item',
                    formatter: '数量 <br/>{b}: {c}'
                },
                grid: {
                    left: '3%',
                    right: '4%',
                    bottom: '3%',
                    containLabel: true
                },
                legend: {
                    data: ['民事', '刑事','行政']
                },
                xAxis: [
                    {
                        type: 'category',
                        data: config.xAxisData,
                        axisTick: {
                            alignWithLabel: true
                        }
                    }
                ],
                yAxis: [
                    {
                        type: 'value'
                    }
                ],
                series: [
                    sumArr(config.series.ms) != 0?
                    {
                        name: '民事',
                        type: 'bar',
                        color:"#4486F6",
                        barWidth: '20%',
                        data: config.series.ms
                    }:"",
                    sumArr(config.series.xs) != 0?
                    {
                        name: '刑事',
                        type: 'bar',
                        color:"#84D7AE",
                        barWidth: '20%',
                        data: config.series.xs
                    }:"",
                    sumArr(config.series.xz) != 0?
                    {
                        name: '行政',
                        type: 'bar',
                        color:"#EDBF57",
                        barWidth: '20%',
                        data: config.series.xz
                    }:""
                ]
            };
        
            break;
        case 'radar': // 雷达图
            option = {
                tooltip: {
                    formatter:function(name){
                        
                        return 
                    } 
                },
                radar: {
                    name: {
                        textStyle: {
                            color: '#fff',
                            backgroundColor: '#999',
                            borderRadius: 3,
                            padding: [3, 5],
                            fontSize:config.isapp?10:12,
                        }
                    },
                    radius:config.isapp?['0%','40%']:['0%','75%'],
                    indicator: config.xAxisData
                },
                series: [{
                    type: 'radar',
                    data: [
                        {
                            value: config.series
                        }
                    ]
                }]
            };
        
            break;
        case 'histogram': // 柱状图
            option = {
                legend: {},
                tooltip: {},
                color: ['#0077da', '#bfe1ff'],
                xAxis: {
                    data: config.xAxisData,
                    splitLine: {
                        show: false
                    }
                },
                series: config.series,
                yAxis: {
                    min: 0
                },
            };
            break;
        case 'histogram_more': // 柱状图
        option = {
            color: ['#3398DB'],
            tooltip: {
                trigger: 'axis',
                axisPointer: {
                    type: 'shadow'    
                }
            },
            grid: {
                left: '3%',
                right: '4%',
                bottom: '3%',
                containLabel: true
            },
            xAxis: [
                {
                    type: 'category',
                    data: config.xAxisData,
                    axisTick: {
                        alignWithLabel: true
                    }
                }
            ],
            yAxis: [
                {
                    type: 'value'
                }
            ],
            series: [
                {
                    type: 'bar',
                    color:"#4486F6",
                    barWidth: '20%',
                    data: config.series
                }
            ]
        };
        
            break;
        case 'barGraph': // 条形图
            option = {
                legend: {},
                tooltip: {},
                color: ['#0077da', '#bfe1ff'],
                xAxis: {
                    type: 'value',
                    min: 0,
                    boundaryGap: [0, 0.01]
                },
                yAxis: {
                    type: 'category',
                    data: config.xAxisData
                },
                series: config.series
            };
            break;
        case 'lineChart': // 折线图
            option = {
                legend: {},
                tooltip: {},
                color: ['#4fc3f7', '#81c784', '#ffd54f', '#ffb64c', '#d9ead3', '#f9cc9c', '#b4a7d7'],
                xAxis: {
                    type: 'category',
                    data: config.xAxisData
                },
                yAxis: {
                    type: 'value',
                    min: 0
                },
                series: config.series
            };
            break;
        case 'stackedGraph': // 堆叠图
            var startValue = config.xAxisData[0];
            var endValue = JSON.parse(JSON.stringify(config.xAxisData)).pop();
            option = {
                legend: {
                    show: false
                },
                grid: {
                    top: 30,
                    left: 0,
                    right: 0,
                    bottom: 20,
                    containLabel: true
                },
                color: ['rgba(40, 130, 228, .1)'],
                tooltip: {
                    trigger: 'axis',
                    axisPointer: {
                        type: 'cross',
                        label: {
                            backgroundColor: '#6a7985'
                        }
                    }
                },
                xAxis: {
                    type: 'category',
                    boundaryGap: true, // x轴两侧留白策略
                    axisLine: {
                        lineStyle: {
                            color: '#c9c9c9',
                            fontSize: 12
                        }
                    },
                    splitLine: {
                        lineStyle: {
                            color: ['#ddd']
                        }
                    },
                    axisTick: {
                        show: false
                    },
                    data: config.xAxisData
                },
                yAxis: {
                    type: 'value',
                    axisLine: {
                        show: false,
                        lineStyle: {
                            color: '#c9c9c9',
                            fontSize: 12
                        }
                    },
                    axisTick: {
                        show: false
                    },
                    splitLine: {
                        lineStyle: {
                            color: ['#ddd']
                        }
                    },
                    min: 0
                },
                dataZoom: [{
                    type: 'slider',
                    startValue: startValue,
                    endValue: endValue,
                    height: 20,
                    borderColor: 'transparent',
                    backgroundColor: 'rgba(40, 130, 228, .1)',
                    dataBackground: {
                        lineStyle: {
                            color: '#2880e4'
                        },
                        areaStyle: {
                            color: '#2880e4',
                        }
                    },
                    fillerColor: 'rgba(40, 128, 228,.35)',
                    // handleIcon: 'M512 512m-208 0a6.5 6.5 0 1 0 416 0 6.5 6.5 0 1 0-416 0Z M512 192C335.264 192 192 335.264 192 512c0 176.736 143.264 320 320 320s320-143.264 320-320C832 335.264 688.736 192 512 192zM512 800c-159.072 0-288-128.928-288-288 0-159.072 128.928-288 288-288s288 128.928 288 288C800 671.072 671.072 800 512 800z',
                    handleColor: '#2880e4',
                    handleSize: 20,
                    right: 50,
                    left: 50,
                    bottom: 0,
                }],
                series: [{
                    name: config.title,
                    type: 'line',
                    data: config.series,
                    areaStyle: {},
                    label: {
                        normal: {
                            show: true,
                            position: 'top',
                            textStyle: {
                                color: ['#2880E4']
                            }
                        }
                    },
                    itemStyle: {
                        normal: {
                            // color: '#8cd5c2', // 改变折线点的颜色
                            lineStyle: {
                                color: '#2880E4' // 改变折线颜色
                            }
                        }
                    },
                    smooth: true
                }]
            };
            break;
        case 'pie': // 饼图
            option = {
                tooltip: {},
                legend: {
                    type: 'scroll',
                    orient: 'vertical',
                    right: 10,
                    bottom: 20,
                },
                color: ['#4fc3f7', '#81c784', '#ffd54f', '#ffb64c', '#d9ead3', '#f9cc9c', '#b4a7d7'],
                grid: {
                    x: 25,
                    y: 45,
                    x2: 5,
                    y2: 20,
                },
                series: {
                    name: '',
                    type: 'pie',
                    radius: '50%',
                    center: ['40%', '50%'],
                    data: config.series,
                    label: {
                        show: true,
                        formatter: '{b} ({d}%)'
                    },
                    emphasis: {
                        itemStyle: {
                            shadowBlur: 10,
                            shadowOffsetX: 0,
                            shadowColor: 'rgba(0, 0, 0, 0.5)'
                        }
                    }
                },
            };
            break;
        case 'doughnut': // 环形图
            option = {
                tooltip: {
                    trigger: 'item',
                    // formatter: '{a} <br/>{b}: {c} ({d}%)'
                    formatter: '{a} <br/>{b}: {c}'
                    // formatter: function (params) {
                    //   console.log(params);
                    //   return params.seriesName + '<br>' + params.name + '：' + params.;
                    // }
                },
                legend: {
                    show: true,
                    type: 'plain',
                    // top: 'middle',
                    // right: 0,
                    bottom : 1,
                    itemWidth: 8,
                    itemHeight: 8,
                    icon: "circle",
                    // orient: 'vertical', // 布局朝向
                    align: 'auto',
                    formatter: function(name) {
                        var data = option.series.data;
                        var total = 0;
                        var tarValue;
                        for (var i = 0, l = data.length; i < l; i++) {
                            total += data[i].value;
                            if (data[i].name == name) {
                                tarValue = data[i].value;
                            }
                        }
                        // 文书类型，legend为数字不是百分比
                        if (config.id == 'vis_case_level') {
                            return '{a|' + name + '}' + ' ' + '{b|' + tarValue + '}'; // 返回富文本
                        } else {
                            var percentage = Math.round(tarValue / total * 10000) / 100;
                            if(percentage != 0){
                                return '{a|' + name + '}' + ' ' + '{b|' + percentage + '%}'; // 返回富文本
                            } else {
                                return '{a|' + name + '}' + ' ' + '{b|' + tarValue + '}'; // 返回富文本
                            }
                        }
                    },
                    textStyle: {
                        rich: {
                            a: {
                                fontSize: 12,
                                color: '#333',
                                verticalAlign: 'middle',
                                align: 'left',
                                padding: [0, 10, 0, 0]
                            },
                            b: {
                                fontSize: 12,
                                color: '#999',
                                verticalAlign: 'middle',
                                align: 'left'
                            }
                        }
                    }
                },
                color: ['#33c1cf', '#fe9d20', '#5976ed', '#50c3f3', '#2880e4','#bad7f9'],
                series: {
                    clickable: true,
                    name: config.title,
                    type: 'pie',
                    minAngle: 5, // 最小扇区占比（防止占比太小显示不出来）
                    radius: ['25%', '48%'], // 兼容移动端
                    center: ['50%', '50%'], // 兼容移动端
                    data: config.series,
                    hoverAnimation: false, // 激活（移入或点击）图表不跳动
                    labelLine: {
                        normal: {
                            length: 10, // 指向折线长
                            length2: 5 // 横向折线长
                        }
                    },
                    label: {
                        show: true,
                        // formatter: '{b} :{c}({d}%)'
                        // formatter: '{b} ({d}%)'
                        formatter: function(name){
                            var html = ""
                                 //APP端
                                html += name.name
                                return html
                                
                        }

                    },
                    // emphasis: {
                    //   itemStyle: {
                    //     shadowBlur: 10,
                    //     shadowOffsetX: 0,
                    //     shadowColor: 'rgba(0, 0, 0, 0.5)'
                    //   }
                    // }
                },
            };
            break;
        case 'combinationChart': // 组合图
            option = {
                legend: {},
                tooltip: {
                    trigger: 'axis',
                    axisPointer: {
                        type: 'cross',
                        label: {
                            backgroundColor: '#283b56'
                        }
                    }
                },
                color: ['#0077da', '#bfe1ff'],
                xAxis: [{
                    type: 'category',
                    boundaryGap: true,
                    splitLine: {
                        show: true,
                        lineStyle: {
                            color: ['#e7e7e7'],
                            width: 1,
                            type: 'dashed'
                        }
                    },
                    data: config.xAxisData
                }, {
                    show: false,
                    type: 'category',
                    boundaryGap: true,
                    splitLine: {
                        show: true,
                        lineStyle: {
                            color: ['#e7e7e7'],
                            width: 1,
                            type: 'dashed'
                        }
                    },
                    data: config.xAxisData
                }],
                yAxis: [{
                    type: 'value',
                    min: 0,
                    name: '',
                    splitLine: {
                        show: true,
                        lineStyle: {
                            color: ['#e7e7e7'],
                            width: 1,
                            type: 'dashed'
                        }
                    },
                    boundaryGap: [0.2, 0.2]
                }, {
                    type: 'value',
                    min: 0,
                    name: '',
                    splitLine: {
                        show: true,
                        lineStyle: {
                            color: ['#e7e7e7'],
                            width: 1,
                            type: 'dashed'
                        }
                    },
                    boundaryGap: [0.2, 0.2]
                }],
                series: config.series,
            };
            break;
        case 'map': // 地图
            option = {
                tooltip: {
                    formatter: function(e, t, n) {
                        return e.name + "：" + e.value;
                        // return e.seriesName + "<br />" + e.name + "：" + e.value
                    }
                },
                visualMap: {
                    show: false,
                    type: 'continuous',
                    min: 0,
                    left: 26,
                    bottom: 0,
                    inRange: {
                        color: ['#e8f4fd', '#1091ed']
                    }
                },
                geo: {
                    map: "china",
                    zoom: 0.8, //当前视角的缩放比例
                    left: '-10%',
                    bottom: 0,
                    top: 0,
                    itemStyle: {
                        normal: {
                            borderColor: "rgba(0, 0, 0, 0.2)"
                        },
                        emphasis: {
                            areaColor: "#fcdc30", // 输入移入省份颜色
                            shadowOffsetX: 0,
                            shadowOffsetY: 0,
                            borderWidth: 0
                        }
                    }
                },
                series: [{
                    name: "数据值",
                    type: "map",
                    geoIndex: 0,
                    data: filterMapData(config.series)
                }]
            }
            option.visualMap.max = visualMap_max; // 设置地图最大值
            break;
    }

    // 标题
    option.title = {
        show: false,
        text: config.title,
        textAlign: 'left',
        left: 10,
        top: 10,
        textStyle: {
            color: '#464646',
            fontWeight: 500,
            fontSize: 14
        }
    };

    // 兼容移动端
    if (mobflag) {
        if (option.legend) {
            option.legend.show = false;
        }
        if (config.type == "doughnut") {
            option.series.label.show = true
            option.series.labelLine = {
                show: true,
                length: 0.1
            }
        }
    }

    // setOption 第二个参数notMerge：可选，是否不跟之前设置的 option 进行合并，默认为 false，即合并
    // document.getElementById(config.id).removeAttribute('_echarts_instance_')
    var myChart = echarts.init(document.getElementById(config.id));
    // myChart.clear();
    myChart.setOption(option, true);
    myChart.on('click', function(param) {
        var id = config.id.replace('vis_', '');
        if (config.type == 'map') {
            $('.map_datalist_item[data-n="' + param.name + '"]').trigger('click');
        } else {
            $('#table_id_' + id).find('.vis_searchbtn button[data-field="' + param.name + '"]').trigger('click');
        }
    })
}

// 四舍五入保留2位小数（不够位数，则用0替补）
function keepTwoDecimalFull(num) {
    var result = parseFloat(num);
    if (isNaN(result)) {
        alert('传递参数错误，请检查！');
        return false;
    }
    result = Math.round(num * 100) / 100;
    var s_x = result.toString();
    var pos_decimal = s_x.indexOf('.');
    if (pos_decimal < 0) {
        pos_decimal = s_x.length;
        s_x += '.';
    }
    while (s_x.length <= pos_decimal + 2) {
        s_x += '0';
    }
    return s_x;
}
function filterMapData(data) {
    var map_list = JSON.parse(JSON.stringify(mapList));
    data.forEach(function(item) {
        map_list.forEach(function(mapData) {
            if (item.name.indexOf(mapData.name) != -1) {
                mapData.value += item.value;
                mapData.key = item.key;
                mapData.id = item.id;
                if (visualMap_max < mapData.value) {
                    visualMap_max = mapData.value;
                }
            }
        })
    })
    map_list.sort(compare('value'))
    return map_list;
}

function compare(property){
    return function(a,b){
        var value1 = a[property];
        var value2 = b[property];
        return value2 - value1;
    }
}

function sumArr(arr){
    var len=arr.length;
    if(len == 0){
       return 0;
    }else if(len==1){
       return arr[0];
    }else{
    return arr[0]+sumArr(arr.slice(1));
    }
}
